
package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.ArticleDao;
import com.ekexiu.console.system.dao.DiscoverBannerDao;
import com.ekexiu.console.system.po.DiscoverBanner;
import com.ekexiu.console.system.vo.ConsoleAuthUser;
import freemarker.cache.StringTemplateLoader;
import freemarker.template.Configuration;
import freemarker.template.TemplateException;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.LoginUser;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.apt.web.annotation.param.RequestParam;
import org.jfw.util.DateUtil;
import org.jfw.util.PageQueryResult;

import java.io.File;
import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

/**
 * Created by TT on 2017/8/25.
 */
@Path("/disBanner")
public class DiscoverBannerService {

    private File generatePath;

    //private Configuration cfg = new Configuration(Configuration.VERSION_2_3_26);

    private String templatePc = "<ul id=\"slide-list\" class=\"slide-list floatL\">\n" +
            "    <li class=\"slide-item slide-item-active\" data-id=\"${banner[0].articleId}\" data-col=\"${banner[0].bannerId}\">\n" +
            "        <a href=\"articalShow.html?articleId=${banner[0].articleId}\" target=\"_blank\" style=\"background-image:url('/data/article/${banner[0].image}');\">\n" +
            "            <p class=\"title\">${banner[0].title}</p>\n" +
            "        </a>\n" +
            "    </li>\n" +
            "    <li class=\"slide-item\" data-id=\"${banner[1].articleId}\" data-col=\"${banner[1].bannerId}\">\n" +
            "        <a href=\"articalShow.html?articleId=${banner[1].articleId}\" target=\"_blank\" style=\"background-image:url('/data/article/${banner[1].image}');\">\n" +
            "            <p class=\"title\">${banner[1].title}</p>\n" +
            "        </a>\n" +
            "    </li>\n" +
            "    <li class=\"slide-item\" data-id=\"${banner[2].articleId}\" data-col=\"${banner[2].bannerId}\">\n" +
            "        <a href=\"articalShow.html?articleId=${banner[2].articleId}\" target=\"_blank\" style=\"background-image:url('/data/article/${banner[2].image}');\">\n" +
            "            <p class=\"title\">${banner[2].title}</p>\n" +
            "        </a>\n" +
            "    </li>\n" +
            "    <li class=\"slide-item\" data-id=\"${banner[3].articleId}\" data-col=\"${banner[3].bannerId}\">\n" +
            "        <a href=\"articalShow.html?articleId=${banner[3].articleId}\" target=\"_blank\" style=\"background-image:url('/data/article/${banner[3].image}');\">\n" +
            "            <p class=\"title\">${banner[3].title}</p>\n" +
            "        </a>\n" +
            "    </li>\n" +
            "    <li class=\"slide-item\" data-id=\"${banner[4].articleId}\" data-col=\"${banner[4].bannerId}\">\n" +
            "        <a href=\"articalShow.html?articleId=${banner[4].articleId}\" target=\"_blank\" style=\"background-image:url('/data/article/${banner[4].image}');\">\n" +
            "            <p class=\"title\">${banner[4].title}</p>\n" +
            "        </a>\n" +
            "    </li>\n" +
            "</ul>\n" +
            "<ul id=\"slide-tab\" class=\"slide-tab floatR\">\n" +
            "    <li class=\"slide-tab-item slide-tab-item-active\">\n" +
            "        ${banner[0].banner}\n" +
            "    </li>\n" +
            "    <li class=\"slide-tab-item\">\n" +
            "        ${banner[1].banner}\n" +
            "    </li>\n" +
            "    <li class=\"slide-tab-item\">\n" +
            "        ${banner[2].banner}\n" +
            "    </li>\n" +
            "    <li class=\"slide-tab-item\">\n" +
            "        ${banner[3].banner}\n" +
            "    </li>\n" +
            "    <li class=\"slide-tab-item\">\n" +
            "        ${banner[4].banner}\n" +
            "    </li>\n" +
            "</ul>";
    private String templateApp = "<div class=\"mui-slider-group mui-slider-loop\">\n" +
            "\n" +
            "    <div class=\"mui-slider-item mui-slider-item-duplicate\" data-id=\"${banner[4].articleId}\" col-id=\"${banner[4].bannerId}\">\n" +
            "        <a href=\"#\" style=\"background-image:url('http://www.ekexiu.com/data/article/${banner[4].image}');\">\n" +
            "            <p class=\"mui-slider-title\">${banner[4].title}</p>\n" +
            "        </a>\n" +
            "    </div>\n" +
            "\n" +
            "    <#list banner as banner>\n" +
            "        <div class=\"mui-slider-item\" data-id=\"${banner.articleId}\" col-id=\"${banner.bannerId}\">\n" +
            "            <a href=\"#\" style=\"background-image:url('http://www.ekexiu.com/data/article/${banner.image}');\">\n" +
            "                <p class=\"mui-slider-title\">${banner.title}</p>\n" +
            "            </a>\n" +
            "        </div>\n" +
            "    </#list>\n" +
            "\n" +
            "    <div class=\"mui-slider-item mui-slider-item-duplicate\" data-id=\"${banner[0].articleId}\" col-id=\"${banner[0].bannerId}\">\n" +
            "        <a href=\"#\" style=\"background-image:url('http://www.ekexiu.com/data/article/${banner[0].image}');\">\n" +
            "            <p class=\"mui-slider-title \">${banner[0].title}</p>\n" +
            "        </a>\n" +
            "    </div>\n" +
            "\n" +
            "</div>\n" +
            "<div class=\"mui-slider-indicator\">\n" +
            "    <div class=\"mui-indicator mui-active\"></div>\n" +
            "    <div class=\"mui-indicator\"></div>\n" +
            "    <div class=\"mui-indicator\"></div>\n" +
            "    <div class=\"mui-indicator\"></div>\n" +
            "    <div class=\"mui-indicator\"></div>\n" +
            "</div>";
    @Autowrie
    private DiscoverBannerDao discoverBannerDao;
    @Autowrie
    private ImageService imageService;
    @Autowrie
    private ArticleDao articleDao;
    @Autowrie
    private TemplateService templateService;

    public DiscoverBannerDao getDiscoverBannerDao() {
        return discoverBannerDao;
    }

    public void setDiscoverBannerDao(DiscoverBannerDao discoverBannerDao) {
        this.discoverBannerDao = discoverBannerDao;
    }

    public ImageService getImageService() {
        return imageService;
    }

    public void setImageService(ImageService imageService) {
        this.imageService = imageService;
    }

    public ArticleDao getArticleDao() {
        return articleDao;
    }

    public void setArticleDao(ArticleDao articleDao) {
        this.articleDao = articleDao;
    }

    public TemplateService getTemplateService() {
        return templateService;
    }

    public void setTemplateService(TemplateService templateService) {
        this.templateService = templateService;
    }

    public File getGeneratePath() {
        return generatePath;
    }

    public void setGeneratePath(File generatePath) {
        this.generatePath = generatePath;
    }

    //public File getSource() {
    //    return source;
    //}

    //public void setSource(File source) {
    //    this.source = source;
    //    try {
    //        this.cfg.setDirectoryForTemplateLoading(source);
    //    } catch (IOException e) {
    //        this.source = null;
    //        this.cfg.setTemplateLoader(new TemplateLoader() {
    //            @Override
    //            public Reader getReader(Object templateSource, String encoding) throws IOException {
    //                StringReader reader = new StringReader("TemplateService'source is invalid dir,so "+templateSource.toString()+" can't read");
    //                return reader;
    //            }
    //
    //            @Override
    //            public long getLastModified(Object templateSource) {
    //                return 0;
    //            }
    //
    //            @Override
    //            public Object findTemplateSource(String name) throws IOException {
    //                return name;
    //            }
    //
    //            @Override
    //            public void closeTemplateSource(Object templateSource) throws IOException {
    //            }
    //        });
    //    }
    //    cfg.setTemplateExceptionHandler(TemplateExceptionHandler.RETHROW_HANDLER);
    //}

    //public void genCnt(String templateName,File dest,Map<String,Object> root) throws IOException, TemplateException {
    //    if(dest.exists()){
    //        if(!dest.delete()){
    //            throw new IOException("delete file["+dest.getAbsolutePath()+"] error");
    //        }
    //    }
    //    Template template = this.cfg.getTemplate(templateName,"UTF-8");
    //    OutputStream out = new FileOutputStream(dest);
    //    try {
    //        template.process(root, new OutputStreamWriter(out, ConstData.UTF8));
    //        out.flush();
    //    } finally {
    //        out.close();
    //    }
    //}

    @Path
    @Post
    public void insert(@JdbcConn(true) Connection con,@RequestParam(excludeFields = {"createTime", "modifyTime", "id"}) DiscoverBanner discoverBanner,@LoginUser ConsoleAuthUser user,@Nullable String fn) throws SQLException, IOException {
        discoverBanner.setCreator(user.getId());
        long id = this.discoverBannerDao.insert(con, discoverBanner);
        if (fn != null) {
            this.imageService.saveBannerImage(id, fn);
        }
    }

    @Path("/id/{id}")
    @Get
    public DiscoverBanner query(@JdbcConn Connection con,@PathVar long id)throws SQLException {
        return this.discoverBannerDao.query(con, id);
    }

    @Path("/update")
    @Post
    public void update(@JdbcConn(true) Connection con, DiscoverBanner banner,@Nullable String fn) throws SQLException, IOException {
        this.discoverBannerDao.update(con, banner);
        this.imageService.saveBannerImage(banner.getId(), fn);
    }

    @Path("/pq")
    @Get
    public PageQueryResult<DiscoverBanner> pageQuery(@JdbcConn Connection con, @Nullable String title, @DefaultValue("1") int pageNo, @DefaultValue("10") int pageSize) throws SQLException {
        return this.discoverBannerDao.query(con,title == null ? null : "%" + title + "%",pageSize,pageNo);
    }

    @Path("/putUp")
    @Post
    public void putOn(@JdbcConn(true) Connection con, Long id1, Long id2, Long id3, Long id4, Long id5, @LoginUser ConsoleAuthUser user) throws SQLException {

        //this.setSource(new File("D:/tmp/banner"));
        StringTemplateLoader stringLoader = new StringTemplateLoader();
        stringLoader.putTemplate("slideTab.html", templatePc);
        stringLoader.putTemplate("appfound.html", templateApp);
        Configuration cfg = templateService.getCfg();
        cfg.setTemplateLoader(stringLoader);
        this.discoverBannerDao.end(con);
        this.discoverBannerDao.clearLocation(con);
        ArrayList<Banner> banners = new ArrayList<>();
        queryId(con, id1, user.getId(), 1, banners);
        queryId(con, id2, user.getId(), 2, banners);
        queryId(con, id3, user.getId(), 3, banners);
        queryId(con, id4, user.getId(), 4, banners);
        queryId(con, id5, user.getId(), 5, banners);
        Map<String, Object> root = new HashMap<String, Object>();
        root.put("banner", banners);
        try {
            //this.genCnt("slideTab.html", new File(generatePath+"/col_banner.html"), root);
            //this.genCnt("appfound.html", new File(generatePath+"/col_bannerApp.html"), root);
            templateService.genCnt(cfg,"slideTab.html", new File(generatePath+"/col_banner.html"), root);
            templateService.genCnt(cfg,"appfound.html", new File(generatePath+"/col_bannerApp.html"), root);
        } catch (IOException | TemplateException e) {
            e.printStackTrace();
        }
    }

    private void queryId(Connection con, Long id, String userId, int location, ArrayList<Banner> banners) throws SQLException {
        DiscoverBanner discoverBanner = this.discoverBannerDao.query(con, id);
        discoverBanner.setBeginTime(DateUtil.formatDateTime(System.currentTimeMillis()));
        discoverBanner.setEndTime(null);
        discoverBanner.setModifier(userId);
        discoverBanner.setLocation(location);
        this.discoverBannerDao.update(con, discoverBanner);
        Banner b = new Banner();
        b.setArticleId(discoverBanner.getArticleId());
        String image = this.articleDao.queryImagePath(con, discoverBanner.getArticleId());
        b.setImage(image);
        b.setBanner(dictBanner(discoverBanner.getBanner()));
        b.setTitle(discoverBanner.getTitle());
        b.setBannerId(id);
        banners.add(b);
    }

    private String dictBanner(int banner) {
        if (Objects.equals(banner, 1) || Objects.equals(banner, 2)) {
            return "原创";
        } else if (Objects.equals(banner, 3)) {
            return "前沿";
        } else if (Objects.equals(banner, 4)) {
            return "经验";
        } else if (Objects.equals(banner, 5)) {
            return "检测";
        } else if (Objects.equals(banner, 6)) {
            return "会议";
        } else if (Objects.equals(banner, 7)) {
            return "访谈";
        } else if (Objects.equals(banner, 8)) {
            return "招聘";
        } else if (Objects.equals(banner, 9)) {
            return "新闻";
        } else {
            return "未设定";
        }
    }
    public static class Banner{
        private String articleId;
        private String image;
        private String title;
        private String banner;
        private Long bannerId;

        public String getArticleId() {
            return articleId;
        }

        public void setArticleId(String articleId) {
            this.articleId = articleId;
        }

        public String getImage() {
            return image;
        }

        public void setImage(String image) {
            this.image = image;
        }

        public String getTitle() {
            return title;
        }

        public void setTitle(String title) {
            this.title = title;
        }

        public String getBanner() {
            return banner;
        }

        public void setBanner(String banner) {
            this.banner = banner;
        }

        public long getBannerId() {
            return bannerId;
        }

        public void setBannerId(Long bannerId) {
            this.bannerId = bannerId;
        }
    }
    
}