package com.ekexiu.console.system.service;

import freemarker.cache.TemplateLoader;
import freemarker.template.Configuration;
import freemarker.template.Template;
import freemarker.template.TemplateException;
import freemarker.template.TemplateExceptionHandler;
import org.jfw.apt.annotation.Bean;
import org.jfw.util.ConstData;

import java.io.*;
import java.util.Map;

/**
 * Created by TT on 2017/8/24.
 */
@Bean
public class TemplateService {

    private File source;
    private Configuration cfg = new Configuration(Configuration.VERSION_2_3_26);

    public Configuration getCfg() {
        return cfg;
    }

    public void setSource(File source) {
        this.source = source;
        try {
            this.cfg.setDirectoryForTemplateLoading(source);
        } catch (IOException e) {
            this.source = null;
            this.cfg.setTemplateLoader(new TemplateLoader() {
                @Override
                public Reader getReader(Object templateSource, String encoding) throws IOException {
                    StringReader reader = new StringReader("TemplateService'source is invalid dir,so "+templateSource.toString()+" can't read");
                    return reader;
                }

                @Override
                public long getLastModified(Object templateSource) {
                    return 0;
                }

                @Override
                public Object findTemplateSource(String name) throws IOException {
                    return name;
                }

                @Override
                public void closeTemplateSource(Object templateSource) throws IOException {
                }
            });
        }
        cfg.setTemplateExceptionHandler(TemplateExceptionHandler.RETHROW_HANDLER);
    }

    public void genCnt(Configuration cfg,String templateName,File dest,Map<String,Object> root) throws IOException, TemplateException {
        if(dest.exists()){
            if(!dest.delete()){
                throw new IOException("delete file["+dest.getAbsolutePath()+"] error");
            }
        }
        Template template = cfg.getTemplate(templateName,"UTF-8");
        OutputStream out = new FileOutputStream(dest);
        try {
            template.process(root, new OutputStreamWriter(out, ConstData.UTF8));
            out.flush();
        } finally {
            out.close();
        }
    }


    public static void main(String[] args) {
        //BannerService templateService = new BannerService();
        ////templateService.setSource(new File("D:/tmp/banner"));
        //StringTemplateLoader stringLoader = new StringTemplateLoader();
        //stringLoader.putTemplate("slideTab",templatePc);
        //stringLoader.putTemplate("appfound",templateApp);
        //templateService.cfg.setTemplateLoader(stringLoader);
        //ArrayList<Banner> banners = new ArrayList<>();
        //ArrayList<Integer> ids = new ArrayList<>();
        //ids.add(30);
        //ids.add(20);
        //ids.add(10);
        //ids.add(50);
        //ids.add(60);
        //for (int i=0;i<5;i++) {
        //    Banner b = new Banner();
        //    b.setId(String.valueOf(ids.get(i)));
        //    b.setImage("image"+i);
        //    b.setBanner("banner"+i);
        //    b.setTitle("title"+i);
        //    banners.add(b);
        //}
        //Map<String, Object> root = new HashMap<String, Object>();
        //root.put("banner", banners);
        //try {
        //    templateService.genCnt("slideTab",new File("D:/tmp/banner/generate.html"),root);
        //    templateService.genCnt("appfound",new File("D:/tmp/banner/generateApp.html"),root);
        //} catch (IOException | TemplateException e) {
        //    e.printStackTrace();
        //}
    }

}
